
_Init_buffer:

;Circular_buffer_LQd.mbas,20 :: 		sub procedure Init_buffer()
;Circular_buffer_LQd.mbas,21 :: 		Circular_buffer_start = 0
	LDI        R27, 0
	STS        _Circular_buffer_start+0, R27
;Circular_buffer_LQd.mbas,22 :: 		Circular_buffer_end = 0
	LDI        R27, 0
	STS        _Circular_buffer_end+0, R27
;Circular_buffer_LQd.mbas,23 :: 		Circular_buffer_load = 0
	LDI        R27, 0
	STS        _Circular_buffer_load+0, R27
;Circular_buffer_LQd.mbas,24 :: 		end sub
L_end_Init_buffer:
	RET
; end of _Init_buffer

_Write_buffer:

;Circular_buffer_LQd.mbas,26 :: 		sub function Write_buffer(dim payload as byte) as boolean
;Circular_buffer_LQd.mbas,28 :: 		if Circular_buffer_load <= Circular_buffer_size then
	LDS        R17, _Circular_buffer_load+0
	LDI        R16, 250
	CP         R16, R17
	BRSH       L__Write_buffer22
	JMP        L__Write_buffer3
L__Write_buffer22:
;Circular_buffer_LQd.mbas,29 :: 		if Circular_buffer_end >= Circular_buffer_size then
	LDS        R16, _Circular_buffer_end+0
	CPI        R16, 250
	BRSH       L__Write_buffer23
	JMP        L__Write_buffer6
L__Write_buffer23:
;Circular_buffer_LQd.mbas,30 :: 		Circular_buffer_space[0] = payload
	STS        _Circular_buffer_space+0, R2
;Circular_buffer_LQd.mbas,31 :: 		Circular_buffer_end = 0
	LDI        R27, 0
	STS        _Circular_buffer_end+0, R27
	JMP        L__Write_buffer7
;Circular_buffer_LQd.mbas,32 :: 		else
L__Write_buffer6:
;Circular_buffer_LQd.mbas,33 :: 		Circular_buffer_space[Circular_buffer_end+1] = payload
	LDS        R16, _Circular_buffer_end+0
	MOV        R18, R16
	SUBI       R18, 255
	LDI        R16, #lo_addr(_Circular_buffer_space+0)
	LDI        R17, hi_addr(_Circular_buffer_space+0)
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	ST         Z, R2
;Circular_buffer_LQd.mbas,34 :: 		Inc(Circular_buffer_end)
	LDS        R16, _Circular_buffer_end+0
	SUBI       R16, 255
	STS        _Circular_buffer_end+0, R16
;Circular_buffer_LQd.mbas,35 :: 		end if
L__Write_buffer7:
;Circular_buffer_LQd.mbas,36 :: 		Inc(Circular_buffer_load)
	LDS        R16, _Circular_buffer_load+0
	SUBI       R16, 255
	STS        _Circular_buffer_load+0, R16
;Circular_buffer_LQd.mbas,37 :: 		result = TRUE
; Result start address is: 17 (R17)
	LDI        R17, 255
; Result end address is: 17 (R17)
	JMP        L__Write_buffer4
;Circular_buffer_LQd.mbas,38 :: 		else
L__Write_buffer3:
;Circular_buffer_LQd.mbas,39 :: 		result = FALSE
; Result start address is: 17 (R17)
	LDI        R17, 0
; Result end address is: 17 (R17)
;Circular_buffer_LQd.mbas,40 :: 		end if
L__Write_buffer4:
;Circular_buffer_LQd.mbas,41 :: 		end sub
; Result start address is: 17 (R17)
	MOV        R16, R17
; Result end address is: 17 (R17)
L_end_Write_buffer:
	RET
; end of _Write_buffer

_Read_buffer:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;Circular_buffer_LQd.mbas,43 :: 		sub function Read_buffer() as byte
;Circular_buffer_LQd.mbas,45 :: 		while Circular_buffer_load = 0
L__Read_buffer10:
	LDS        R16, _Circular_buffer_load+0
	CPI        R16, 0
	BRNE       L__Read_buffer25
	JMP        L__Read_buffer10
L__Read_buffer25:
;Circular_buffer_LQd.mbas,48 :: 		if Circular_buffer_load > 0 then
	LDS        R17, _Circular_buffer_load+0
	LDI        R16, 0
	CP         R16, R17
	BRLO       L__Read_buffer26
	JMP        L__Read_buffer15
L__Read_buffer26:
;Circular_buffer_LQd.mbas,49 :: 		if Circular_buffer_start >= Circular_buffer_size then
	LDS        R16, _Circular_buffer_start+0
	CPI        R16, 250
	BRSH       L__Read_buffer27
	JMP        L__Read_buffer18
L__Read_buffer27:
;Circular_buffer_LQd.mbas,50 :: 		result = Circular_buffer_space[0]
	LDS        R16, _Circular_buffer_space+0
	STD        Y+0, R16
;Circular_buffer_LQd.mbas,51 :: 		Circular_buffer_start = 0
	LDI        R27, 0
	STS        _Circular_buffer_start+0, R27
	JMP        L__Read_buffer19
;Circular_buffer_LQd.mbas,52 :: 		else
L__Read_buffer18:
;Circular_buffer_LQd.mbas,53 :: 		result = Circular_buffer_space[Circular_buffer_start+1]
	LDS        R16, _Circular_buffer_start+0
	MOV        R18, R16
	SUBI       R18, 255
	LDI        R16, #lo_addr(_Circular_buffer_space+0)
	LDI        R17, hi_addr(_Circular_buffer_space+0)
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
	STD        Y+0, R16
;Circular_buffer_LQd.mbas,54 :: 		Inc(Circular_buffer_start)
	STS        _Circular_buffer_start+0, R18
;Circular_buffer_LQd.mbas,55 :: 		end if
L__Read_buffer19:
;Circular_buffer_LQd.mbas,56 :: 		Dec(Circular_buffer_load)
	LDS        R16, _Circular_buffer_load+0
	SUBI       R16, 1
	STS        _Circular_buffer_load+0, R16
L__Read_buffer15:
;Circular_buffer_LQd.mbas,58 :: 		end sub
	LDD        R16, Y+0
L_end_Read_buffer:
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Read_buffer

_Circular_buffer_LQd_?main:

;Circular_buffer_LQd.mbas,61 :: 		end.
L_end_Circular_buffer_LQd_?main:
	RET
; end of _Circular_buffer_LQd_?main
